Codeforces Round #235 (Div. 2)
1 second
256 megabytes
standard input
standard output
Vanya loves playing. He even has a special set of cards to play with. Each card has a single integer. The number on the card can be positive, negative and can even be equal to zero. The only limit is, the number on each card doesn't exceed x in the absolute value.
Natasha doesn't like when Vanya spends a long time playing, so she hid all of his cards. Vanya became sad and started looking for the cards but he only found n of them. Vanya loves the balance, so he wants the sum of all numbers on found cards equal to zero. On the other hand, he got very tired of looking for cards. Help the boy and say what is the minimum number of cards does he need to find to make the sum equal to zero?
You can assume that initially Vanya had infinitely many cards with each integer number from - x to x.
The first line contains two integers: n (1 ≤ n ≤ 1000) — the number of found cards and x (1 ≤ x ≤ 1000) — the maximum absolute value of the number on a card. The second line contains n space-separated integers — the numbers on found cards. It is guaranteed that the numbers do not exceed x in their absolute value.
Print a single number — the answer to the problem.
3 2
-1 1 2
1
2 3
-2 -2
2
题意:就是求一个最小操作数(绝水)
sl:直接模拟。 1 #include <cstdio>
2 #include <cstring>
3 #include <algorithm>
4 typedef long long ll;
5 using namespace std;
6 const int MAX =+ ;
7 int a[MAX];
8 int main()
9 {
int n,x;
int ans;
while(scanf("%d %d",&n,&x)==)
{
ans=;
for(int i=;i<n;i++)
{
scanf("%d",&a[i]);
ans+=a[i];
}
int cnt=;
if(ans==) printf("0\n");
else if(ans>)
{
while(ans>=x)
{
cnt++;
ans-=x;
}
if(ans!=) cnt++;
printf("%d\n",cnt);
}
else
{
while(abs(ans)>=x)
{
cnt++;
ans+=x;
}
if(ans!=) cnt++;
printf("%d\n",cnt);
}
}
return ;
44 }
1 second
256 megabytes
standard input
standard output
Sereja is a coder and he likes to take part in Codesorfes rounds. However, Uzhland doesn't have good internet connection, so Sereja sometimes skips rounds.
Codesorfes has rounds of two types: Div1 (for advanced coders) and Div2 (for beginner coders). Two rounds, Div1 and Div2, can go simultaneously, (Div1 round cannot be held without Div2) in all other cases the rounds don't overlap in time. Each round has a unique identifier — a positive integer. The rounds are sequentially (without gaps) numbered with identifiers by the starting time of the round. The identifiers of rounds that are run simultaneously are different by one, also the identifier of the Div1 round is always greater.
Sereja is a beginner coder, so he can take part only in rounds of Div2 type. At the moment he is taking part in a Div2 round, its identifier equals tox. Sereja remembers very well that he has taken part in exactly k rounds before this round. Also, he remembers all identifiers of the rounds he has taken part in and all identifiers of the rounds that went simultaneously with them. Sereja doesn't remember anything about the rounds he missed.
Sereja is wondering: what minimum and what maximum number of Div2 rounds could he have missed? Help him find these two numbers.
The first line contains two integers: x (1 ≤ x ≤ 4000) — the round Sereja is taking part in today, and k (0 ≤ k < 4000) — the number of rounds he took part in.
Next k lines contain the descriptions of the rounds that Sereja took part in before. If Sereja took part in one of two simultaneous rounds, the corresponding line looks like: "1 num2 num1" (where num2 is the identifier of this Div2 round, num1 is the identifier of the Div1 round). It is guaranteed that num1 - num2 = 1. If Sereja took part in a usual Div2 round, then the corresponding line looks like: "2 num" (where num is the identifier of this Div2 round). It is guaranteed that the identifiers of all given rounds are less than x.
Print in a single line two integers — the minimum and the maximum number of rounds that Sereja could have missed.
3 2
2 1
2 2
0 0
9 3
1 2 3
2 8
1 4 5
2 3
10 0
5 9
题意:每场比赛都有一个特定的标号,每次给出每场比赛的标号,问之前最多和最少参加了多少场div2
sol:还是模拟最多肯定是全部都是div2,最少肯定是都是1,2一起举行,多出来的部分用div2补全
1 #include <cstdio>
2 #include <cstring>
3 #include <algorithm>
4 typedef long long ll;
5 using namespace std;
6 const int MAX = +;
7 int vis[MAX];
8 int main()
9 {
int k,x,t; int num1,num2;
while(scanf("%d %d",&x,&k)==)
{
memset(vis,,sizeof(vis));
for(int i=;i<k;i++)
{
scanf("%d",&t);
if(t==)
{
scanf("%d",&num2);
vis[num2]=;
}
if(t==)
{
scanf("%d %d",&num1,&num2);
vis[num1]=vis[num2]=;
}
}
int Min=,Max=;
for(int i=;i<x;i++)
{
if(!vis[i]&&!vis[i+]&&(i+)<x)
{
Min++;
i++;
}
else if(i<x&&!vis[i])
{
Min++;
}
}
for(int i=;i<x;i++)
{
if(!vis[i]) Max++;
}
printf("%d %d\n",Min,Max);
}
return ;
48 }
1 second
256 megabytes
standard input
standard output
Now it's time of Olympiads. Vanya and Egor decided to make his own team to take part in a programming Olympiad. They've been best friends ever since primary school and hopefully, that can somehow help them in teamwork.
For each team Olympiad, Vanya takes his play cards with numbers. He takes only the cards containing numbers 1 and 0. The boys are very superstitious. They think that they can do well at the Olympiad if they begin with laying all the cards in a row so that:
- there wouldn't be a pair of any side-adjacent cards with zeroes in a row;
- there wouldn't be a group of three consecutive cards containing numbers one.
Today Vanya brought n cards with zeroes and m cards with numbers one. The number of cards was so much that the friends do not know how to put all those cards in the described way. Help them find the required arrangement of the cards or else tell the guys that it is impossible to arrange cards in such a way.
The first line contains two integers: n (1 ≤ n ≤ 106) — the number of cards containing number 0; m (1 ≤ m ≤ 106) — the number of cards containing number 1.
In a single line print the required sequence of zeroes and ones without any spaces. If such sequence is impossible to obtain, print -1.
1 2
101
4 8
110110110101
4 10
11011011011011
1 5
-1
题意:就是给出1的个数和0的个数,求出一个满足没有连续的两个0和连续的三个1的序列
sl:一共就三种情况可以算出三个公式吧,很简单,比赛时没注意算了 6种情况
随便来一种情况: |-|-|--|--|--|-
"|"代表0个数设为k
"-" 代表1总共m个
有: k+(n-1-k)*2+1=m 满足k>=0时有解。其余类似。剩下的就是输出答案了
1 #include <cstdio>
2 #include <cstring>
3 #include <algorithm>
4 typedef long long ll;
5 using namespace std;
6 const int MAX =1e6+;
7 int num[MAX];
8 int main()
9 {
int n,m;
while(scanf("%d %d",&n,&m)==)
{
int Max=max(n,m);
if(n>=m+) printf("-1\n");
else if(n==m+)
{
for(int i=;i<m;i++) printf("");
printf("");
printf("\n");
}
else if(n==m)
{
for(int i=;i<m;i++) printf("");
printf("\n");
}
else if(*n-m>=)
{
printf("");
for(int i=;i<*n-m;i++) printf("");
for(int i=;i<n--*n+m;i++) printf("");
printf("");
printf("\n");
}
else if(*n-m->=)
{
printf("");
for(int i=;i<*n-m-;i++) printf("");
for(int i=;i<n-*n+m;i++) printf("");
printf("");
printf("\n");
}
else if(*n-m->=)
{
printf("");
for(int i=;i<*n-m-;i++) printf("");
for(int i=;i<n-*n+m+;i++) printf("");
printf("\n");
}
else if(*n-m+>=)
{
for(int i=;i<*n-m+;i++) printf("");
for(int i=;i<n-*n+m-;i++) printf("");
printf("");
printf("\n");
}
else if(*n-m+>=)
{
for(int i=;i<*n-m+;i++) printf("");
for(int i=;i<n-*n+m-;i++) printf("");
printf("");
printf("\n");
}
else if(*n-m>=)
{
for(int i=;i<*n-m;i++) printf("");
for(int i=;i<n-*n+m;i++) printf("");
printf("\n");
}
}
return ;
71 }
4 seconds
512 megabytes
standard input
standard output
Roman is a young mathematician, very famous in Uzhland. Unfortunately, Sereja doesn't think so. To make Sereja change his mind, Roman is ready to solve any mathematical problem. After some thought, Sereja asked Roma to find, how many numbers are close to number n, modulo m.
Number x is considered close to number n modulo m, if:
- it can be obtained by rearranging the digits of number n,
- it doesn't have any leading zeroes,
- the remainder after dividing number x by m equals 0.
Roman is a good mathematician, but the number of such numbers is too huge for him. So he asks you to help him.
The first line contains two integers: n (1 ≤ n < 1018) and m (1 ≤ m ≤ 100).
In a single line print a single integer — the number of numbers close to number n modulo m.
104 2
3
223 4
1
7067678 8
47
题意:给出一个数字n和m求出与数字n相近的数,这个数满足:他是n的每位数字的重新排列,用它%m为0,没有前导0。求满足条件的总数。
sol: dp题目。--(当时不会么,状压学的太烂了) ,枚举每一位的状态,(从后枚举)
方程:dp[i|1<<j][(k*10+a[j])%m]+=dp[i][k]; dp【i】[j] 表示每位状态为i余数为j时的总数。
具体参考代码。 1 #include<cstdio>
2 #include<cstring>
3 #include<algorithm>
4 using namespace std;
5
6 long long dp[<<][],d,f[];
7 int main()
8 {
9 int m,l,n,i,j,k,c[];
char a[];
memset(c,,sizeof(c));
for(f[]=,i=;i<;i++)
f[i]=f[i-]*i; //计算阶乘
scanf("%s%d",a,&m);
l=strlen(a),n=<<l;
for(i=;i<l;i++)
c[a[i]-='']++; //保存每个数字的个数
for(d=,i=;i<;i++)
d*=f[c[i]]; //重复的个数
dp[][]=;
for(i=;i<n;i++)
for(j=;j<l;j++)
if(!(i&<<j)) //此处数字已经去过了不用再去取了从后往前取
for(k=;k<m;k++)
if(!(i==&&a[j]==)) //当i!=0时 最高位肯定不是0随便取
dp[i|<<j][(k*+a[j])%m]+=dp[i][k];
printf("%I64d\n",dp[n-][]/d);
return ;
34 }
PS:yy了一下大牛,貌似可以将数列,分成两半然后暴力求解时间复杂度为O(2^9);
Codeforces Round #235 (Div. 2)的更多相关文章
- Codeforces Round #235 (Div. 2) D. Roman and Numbers(如压力dp)
Roman and Numbers time limit per test 4 seconds memory limit per test 512 megabytes input standard i ...
- Codeforces Round #235 (Div. 2) D. Roman and Numbers 状压dp+数位dp
题目链接: http://codeforces.com/problemset/problem/401/D D. Roman and Numbers time limit per test4 secon ...
- Codeforces Round #235 (Div. 2)C、Team
#include <iostream> #include <algorithm> using namespace std; int main(){ int n,m; cin & ...
- Codeforces Round #235 (Div. 2) B. Sereja and Contests
#include <iostream> #include <vector> #include <algorithm> using namespace std; in ...
- Codeforces Round #235 (Div. 2) A. Vanya and Cards
#include <iostream> using namespace std; int main(){ int n,x; cin >> n >> x; ; ; i ...
- Codeforces Round #235 (Div. 2) D. Roman and Numbers (数位dp、状态压缩)
D. Roman and Numbers time limit per test 4 seconds memory limit per test 512 megabytes input standar ...
- Codeforces Round #235 (Div. 2) C. Team
C. Team time limit per test 1 second memory limit per test 256 megabytes input standard input output ...
- Codeforces Round #235 (Div. 2) D (dp)
以为是组合,后来看着像数位dp,又不知道怎么让它不重复用..然后就没思路 了. 其实状压就可以了 状压是可以确定一个数的使用顺序的 利用01也可以确定所有的数的使用以及不重复 dp[i+1<&l ...
- Codeforces Round #366 (Div. 2) ABC
Codeforces Round #366 (Div. 2) A I hate that I love that I hate it水题 #I hate that I love that I hate ...
随机推荐
- c++病毒函数
FreeConsole(); 屏蔽输出. BlockInput(); 阻止键盘和鼠标的工作. 所需头文件: #include <windows.h> #include <Winabl ...
- POJ 2773 欧几里得
思路: 若a和b互素的话,则b*t+a和b一定互素 用周期性做就好了 //By SiriusRen #include <cstdio> using namespace std; ],m,k ...
- Manacher HDOJ 5371 Hotaru's problem
题目传送门 /* 题意:求形如(2 3 4) (4 3 2) (2 3 4)的最长长度,即两个重叠一半的回文串 Manacher:比赛看到这题还以为套个模板就行了,因为BC上有道类似的题,自己又学过M ...
- 通过路由器的IP映射来解决,两个不同IP地址的PC机之间的从LAN口到WAN口的单向通讯问题
1.问题假设: 在B机中IP地址与子网掩码都固定,网关是路由器的LAN口的IP地址,我们希望通过路由器来实现B机与A机之间的单向通讯问题,也就是说B可以ping通A且可以访问A提供的FTP站点. 2. ...
- Android 性能优化(10)网络优化( 6)Optimizing General Network Use
Optimizing General Network Use This lesson teaches you to Compress Data Cache Files Locally Optimize ...
- Markdown基本语法学习
Markdown是一种纯文本格式的标记语言.通过简单的标记语法,它可以使普通文本内容具有一定的格式. 创始人 John Gruber 的 Markdown 语法说明 Markdown 中文版语法说明 ...
- 2016天池-O2O优惠券使用预测竞赛总结
第一次参加数据预测竞赛,发现还是挺有意思的.本文中的部分内容参考第一名“诗人都藏在水底”的解决方案. 从数据划分.特征提取.模型设计.模型融合/优化,整个业务流程得到了训练.作为新手在数据划分和模型训 ...
- C++中图片重命名
非常简单的小程序,满足自己的需求. #include <iostream> #include <fstream> #include<sstream> using n ...
- 【转】jvm类加载
类加载机制 JVM把class文件加载的内存,并对数据进行校验.转换解析和初始化,最终形成JVM可以直接使用的Java类型的过程就是加载机制. 类从被加载到虚拟机内存中开始,到卸载出内存为止,它的生命 ...
- thinkphp信息修改和分页
关联两个数据表,在Model里建立StuModel.class.php: <?php //Belongs_to 关联表示当前模型从属于另外一个父对象 namespace Admin\Model; ...